(ns example-webapp.handler
  (:require [compojure.core :refer [routes wrap-routes]]
            [example-webapp.layout :refer [error-page]]
            [example-webapp.routes.home :refer [home-routes]]
            [compojure.route :as route]
            [example-webapp.env :refer [defaults]]
            [mount.core :as mount]
            [example-webapp.middleware :as middleware]))

(mount/defstate init-app
  :start ((or (:init defaults) identity))
  :stop  ((or (:stop defaults) identity)))

(mount/defstate app
  :start
  (middleware/wrap-base
    (routes
      (-> #'home-routes
          (wrap-routes middleware/wrap-csrf)
          (wrap-routes middleware/wrap-formats))
      (route/not-found
        (:body
          (error-page {:status 404
                       :title "page not found"}))))))
